CTAGS(1)

NAME
ctags - create a tags file

SYNOPSIS
ctags [-aBdFuvwx] [-f tagsfile] file ...

DESCRIPTION
ctags makes a tags file from the specified C, Pascal, Fortran, YACC, lex, and Lisp sources. A tags file gives the locations of specified objects in a group of files. Each line of the tags file contains the object name, the file in which it is defined, and a search pattern for the object definition, separated by whitespace.

Using the tags file, a text editor such as ex(1) or vi(1) can quickly locate these object definitions. Indexed objects include subroutines, typedefs, defines, structs, enums, and unions.

The options are as follows:

-a  Append to tags file.

-B  Use backward searching patterns (?...?).

-d  Create tags for #defines that don't take arguments; #defines that take arguments are tagged automatically.

-F  Use forward searching patterns (/.../) (the default).

-f tagsfile
    Places the tag descriptions in a file called tagsfile. The default behaviour is to place them in a file called tags.

-u  Update the specified files in the tags file; that is, all references to them are regenerated, keeping only the other values in the file.

-v  An index of the form expected by vgrind is produced on the standard output. This listing contains the object name, file name, and page number (assuming 64 line pages). Since the output will be sorted into lexicographic order, it may be desired to run the output through sort(1). Sample use:

        $ ctags -v files | sort -f > index
        $ vgrind -x index

-w  Suppress warning diagnostics.

-x  ctags produces a list of object names, the line number and file name on which each is defined, as well as the text of that line and prints this on the standard output. This is a simple index which can be printed out as an off-line readable function index.

Files whose names end in “.c” or “.h” are assumed to be C source files and are searched for C style routine and macro definitions. Files whose names end in “.y” are assumed to be yacc(1) source files. Files whose names end in “.l” are assumed to be Lisp files if their first non-blank character is ‘’;, ‘(’, or ‘[’, otherwise, they are treated as lex files. Other files are first examined to see if they contain any Pascal or Fortran routine definitions and, if not, are searched for C style definitions.

The tag main is treated specially in C programs. The tag formed is created by prepending ‘M’ to the name of the file, with the trailing “.c” and any leading pathname components removed. This makes use of ctags practical in directories with more than one program.

Yacc and lex files each have a special tag. yyparse is the start of the second section of the yacc file, and yylex is the start of the second section of the lex file.

FILES
tags
    default output tags file

EXIT STATUS

Duplicate objects are not considered errors.

SEE ALSO
mg(1), vi(1)

STANDARDS
The ctags utility is compliant with the p1003.1-2008 specification, though its presence is optional.

The flags [-BdFuvw] are extensions to that specification.

Support for Pascal, YACC, lex, and Lisp source files is an p1003.1-2008 extension. The standard notes that ctags is " not required to accommodate these languages, although implementors are encouraged to do so ".

HISTORY
The ctags command appeared in 2BSD.

BUGS
Recognition of functions, subroutines, and procedures for FORTRAN and Pascal is done in a very simple-minded way. No attempt is made to deal with block structure; if you have two Pascal procedures in different blocks with the same name you lose. ctags doesn't understand about Pascal types.

The method of deciding whether to look for C, Pascal or FORTRAN functions is a hack.

ctags relies on the input being well formed, and any syntactical errors will completely confuse it. It also finds some legal syntax confusing; for example, since it doesn't understand #ifdef's (incidentally, that's a feature, not a bug), any code with unbalanced braces inside #ifdef's will cause it to become somewhat disoriented. In a similar fashion, multiple line changes within a definition will cause it to enter the last line of the object, rather than the first, as the searching pattern. The last line of multiple line typedef's will similarly be noted.